Index: 1.8/main/features.c
===================================================================
--- 1.8/main/features.c	(revision 403498)
+++ 1.8/main/features.c	(working copy)
@@ -4497,7 +4497,7 @@
 	/* If the channel CDR has been modified during the call, record the changes in the bridge cdr,
 	 * BUT, if we've gone through the h extension block above, the CDR got swapped so don't overwrite
 	 * what was done in the h extension. What a mess. This is why you never touch CDR code. */
-	if (new_chan_cdr && bridge_cdr && !h_context) {
+	if (new_chan_cdr && bridge_cdr && !h_context && chan->cdr == chan_cdr) {
 		ast_cdr_copy_vars(bridge_cdr, new_chan_cdr);
 		ast_copy_string(bridge_cdr->userfield, new_chan_cdr->userfield, sizeof(bridge_cdr->userfield));
 		bridge_cdr->amaflags = new_chan_cdr->amaflags;
Index: 10/main/features.c
===================================================================
--- 10/main/features.c	(revision 403498)
+++ 10/main/features.c	(working copy)
@@ -4501,7 +4501,7 @@
 	/* If the channel CDR has been modified during the call, record the changes in the bridge cdr,
 	 * BUT, if we've gone through the h extension block above, the CDR got swapped so don't overwrite
 	 * what was done in the h extension. What a mess. This is why you never touch CDR code. */
-	if (new_chan_cdr && bridge_cdr && !h_context) {
+	if (new_chan_cdr && bridge_cdr && !h_context && chan->cdr == chan_cdr) {
 		ast_cdr_copy_vars(bridge_cdr, new_chan_cdr);
 		ast_copy_string(bridge_cdr->userfield, new_chan_cdr->userfield, sizeof(bridge_cdr->userfield));
 		bridge_cdr->amaflags = new_chan_cdr->amaflags;
Index: 11/main/features.c
===================================================================
--- 11/main/features.c	(revision 403498)
+++ 11/main/features.c	(working copy)
@@ -4828,7 +4828,7 @@
 	 * h-extension or hangup handlers.  What a mess.  This is why
 	 * you never touch CDR code.
 	 */
-	if (new_chan_cdr && bridge_cdr && !hangup_run) {
+	if (new_chan_cdr && bridge_cdr && !hangup_run && ast_channel_cdr(chan) == chan_cdr) {
 		ast_cdr_copy_vars(bridge_cdr, new_chan_cdr);
 		ast_copy_string(bridge_cdr->userfield, new_chan_cdr->userfield, sizeof(bridge_cdr->userfield));
 		bridge_cdr->amaflags = new_chan_cdr->amaflags;
